/* engine.c generated by valac 0.16.1, the Vala compiler
 * generated from engine.vala, do not modify */

/* 
 * Copyright (C) 2011-2013 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2013 Red Hat, Inc.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <ibus.h>
#include <libkkc/libkkc.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <libutil.h>
#include <config.h>
#include <locale.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>
#include <gdk/gdk.h>


#define TYPE_KKC_ENGINE (kkc_engine_get_type ())
#define KKC_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KKC_ENGINE, KkcEngine))
#define KKC_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KKC_ENGINE, KkcEngineClass))
#define IS_KKC_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KKC_ENGINE))
#define IS_KKC_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KKC_ENGINE))
#define KKC_ENGINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KKC_ENGINE, KkcEngineClass))

typedef struct _KkcEngine KkcEngine;
typedef struct _KkcEngineClass KkcEngineClass;
typedef struct _KkcEnginePrivate KkcEnginePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define KKC_ENGINE_TYPE_KEY_ENTRY (kkc_engine_key_entry_get_type ())
typedef struct _KkcEngineKeyEntry KkcEngineKeyEntry;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))

struct _KkcEngine {
	IBusEngine parent_instance;
	KkcEnginePrivate * priv;
};

struct _KkcEngineClass {
	IBusEngineClass parent_class;
};

struct _KkcEnginePrivate {
	KkcContext* context;
	IBusLookupTable* lookup_table;
	guint page_start;
	gboolean lookup_table_visible;
	gboolean show_annotation;
	IBusProperty* input_mode_prop;
	IBusPropList* prop_list;
	GeeMap* input_mode_props;
	GeeMap* input_mode_symbols;
	GeeMap* name_input_modes;
	GtkClipboard* clipboard;
	gchar** LOOKUP_TABLE_LABELS;
	gint LOOKUP_TABLE_LABELS_length1;
	gint _LOOKUP_TABLE_LABELS_size_;
	guint save_dictionaries_timeout_id;
};

struct _KkcEngineKeyEntry {
	guint keyval;
	guint modifiers;
};


static gpointer kkc_engine_parent_class = NULL;
static Preferences* kkc_engine_preferences;
static Preferences* kkc_engine_preferences = NULL;
static GeeArrayList* kkc_engine_dictionaries;
static GeeArrayList* kkc_engine_dictionaries = NULL;
static gboolean kkc_engine_ibus;
static gboolean kkc_engine_ibus = FALSE;

GType kkc_engine_get_type (void) G_GNUC_CONST;
#define KKC_ENGINE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_KKC_ENGINE, KkcEnginePrivate))
enum  {
	KKC_ENGINE_DUMMY_PROPERTY
};
static GType kkc_engine_key_entry_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static KkcEngineKeyEntry* kkc_engine_key_entry_dup (const KkcEngineKeyEntry* self);
static void kkc_engine_key_entry_free (KkcEngineKeyEntry* self);
static void kkc_engine_set_selection_text (GtkClipboard* clipboard, const gchar* text, KkcEngine* self);
static void kkc_engine_populate_lookup_table (KkcEngine* self);
static void kkc_engine_set_lookup_table_cursor_pos (KkcEngine* self);
static void kkc_engine_update_preedit (KkcEngine* self);
static void kkc_engine_update_candidates (KkcEngine* self);
static void kkc_engine_update_input_mode (KkcEngine* self);
static KkcDictionary* kkc_engine_parse_dict_from_plist (PList* plist, GError** error);
static void kkc_engine_reload_dictionaries (void);
static void kkc_engine_apply_preferences (KkcEngine* self);
static IBusProperty* kkc_engine_register_input_mode_property (KkcEngine* self, KkcInputMode mode, const gchar* name, const gchar* label, const gchar* symbol);
static gboolean kkc_engine_process_lookup_table_key_event (KkcEngine* self, guint keyval, guint keycode, guint state);
static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle);
static gboolean kkc_engine_real_process_key_event (IBusEngine* base, guint keyval, guint keycode, guint state);
static void kkc_engine_real_enable (IBusEngine* base);
static gboolean __lambda2_ (KkcEngine* self);
static gboolean ___lambda2__gsource_func (gpointer self);
static void kkc_engine_real_disable (IBusEngine* base);
static void kkc_engine_real_reset (IBusEngine* base);
static void kkc_engine_real_focus_in (IBusEngine* base);
static void kkc_engine_real_focus_out (IBusEngine* base);
static void kkc_engine_real_property_activate (IBusEngine* base, const gchar* prop_name, guint prop_state);
gint kkc_engine_main (gchar** args, int args_length1);
static void __lambda3_ (void);
static void ___lambda3__ibus_bus_disconnected (IBusBus* _sender, gpointer self);
static void __lambda4_ (const gchar* name, GVariant* value);
static void ___lambda4__preferences_value_changed (Preferences* _sender, const gchar* name, GVariant* value, gpointer self);
KkcEngine* kkc_engine_new (void);
KkcEngine* kkc_engine_construct (GType object_type);
static GObject * kkc_engine_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _kkc_engine___lambda5_ (KkcEngine* self, const gchar* name, GVariant* value);
static void __kkc_engine___lambda5__preferences_value_changed (Preferences* _sender, const gchar* name, GVariant* value, gpointer self);
static void _kkc_engine___lambda6_ (KkcEngine* self, const gchar* name, GVariant* value);
static void __kkc_engine___lambda6__preferences_value_changed (Preferences* _sender, const gchar* name, GVariant* value, gpointer self);
static void _kkc_engine___lambda7_ (KkcEngine* self);
static void __kkc_engine___lambda7__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void _kkc_engine___lambda8_ (KkcEngine* self, GObject* s, GParamSpec* p);
static void __kkc_engine___lambda8__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void _kkc_engine___lambda9_ (KkcEngine* self);
static void __kkc_engine___lambda9__kkc_candidate_list_populated (KkcCandidateList* _sender, gpointer self);
static void _kkc_engine___lambda10_ (KkcEngine* self);
static void __kkc_engine___lambda10__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void _kkc_engine___lambda11_ (KkcEngine* self);
static void __kkc_engine___lambda11__kkc_candidate_list_selected (KkcCandidateList* _sender, KkcCandidate* candidate, gpointer self);
static void _kkc_engine___lambda12_ (KkcEngine* self, KkcContext* e);
static void __kkc_engine___lambda12__kkc_context_request_selection_text (KkcContext* _sender, gpointer self);
static void kkc_engine_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const KkcEngineKeyEntry KKC_ENGINE_IGNORE_KEYS[1] = {{(guint) IBUS_j, (guint) IBUS_CONTROL_MASK}};
static const GOptionEntry KKC_ENGINE_options[2] = {{"ibus", 'i', 0, G_OPTION_ARG_NONE, &kkc_engine_ibus, "Component is executed by IBus", NULL}, {NULL}};

static void kkc_engine_set_selection_text (GtkClipboard* clipboard, const gchar* text, KkcEngine* self) {
	KkcContext* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (clipboard != NULL);
	_tmp0_ = self->priv->context;
	_tmp1_ = text;
	kkc_context_set_selection_text (_tmp0_, _tmp1_);
}


static void kkc_engine_populate_lookup_table (KkcEngine* self) {
	IBusLookupTable* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->lookup_table;
	ibus_lookup_table_clear (_tmp0_);
	{
		guint _tmp1_;
		gint i;
		_tmp1_ = self->priv->page_start;
		i = (gint) _tmp1_;
		{
			gboolean _tmp2_;
			_tmp2_ = TRUE;
			while (TRUE) {
				gboolean _tmp3_;
				gint _tmp5_;
				KkcContext* _tmp6_;
				KkcCandidateList* _tmp7_;
				KkcCandidateList* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				KkcContext* _tmp11_;
				KkcCandidateList* _tmp12_;
				KkcCandidateList* _tmp13_;
				gint _tmp14_;
				KkcCandidate* _tmp15_ = NULL;
				KkcCandidate* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				IBusText* _tmp19_;
				IBusText* _tmp20_;
				IBusText* _tmp21_;
				IBusText* text;
				IBusLookupTable* _tmp22_;
				IBusText* _tmp23_;
				_tmp3_ = _tmp2_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp5_ = i;
				_tmp6_ = self->priv->context;
				_tmp7_ = kkc_context_get_candidates (_tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = kkc_candidate_list_get_size (_tmp8_);
				_tmp10_ = _tmp9_;
				if (!(_tmp5_ < _tmp10_)) {
					break;
				}
				_tmp11_ = self->priv->context;
				_tmp12_ = kkc_context_get_candidates (_tmp11_);
				_tmp13_ = _tmp12_;
				_tmp14_ = i;
				_tmp15_ = kkc_candidate_list_get (_tmp13_, _tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = kkc_candidate_get_output (_tmp16_);
				_tmp18_ = _tmp17_;
				_tmp19_ = ibus_text_new_from_string (_tmp18_);
				_tmp20_ = g_object_ref_sink (_tmp19_);
				_tmp21_ = _tmp20_;
				_g_object_unref0 (_tmp16_);
				text = _tmp21_;
				_tmp22_ = self->priv->lookup_table;
				_tmp23_ = text;
				ibus_lookup_table_append_candidate (_tmp22_, _tmp23_);
				_g_object_unref0 (text);
			}
		}
	}
}


static void kkc_engine_set_lookup_table_cursor_pos (KkcEngine* self) {
	IBusText* _tmp0_;
	IBusText* _tmp1_;
	IBusText* empty_text;
	KkcContext* _tmp2_;
	KkcCandidateList* _tmp3_;
	KkcCandidateList* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint cursor_pos;
	KkcContext* _tmp7_;
	KkcCandidateList* _tmp8_;
	KkcCandidateList* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	g_return_if_fail (self != NULL);
	_tmp0_ = ibus_text_new_from_static_string ("");
	_tmp1_ = g_object_ref_sink (_tmp0_);
	empty_text = _tmp1_;
	_tmp2_ = self->priv->context;
	_tmp3_ = kkc_context_get_candidates (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = kkc_candidate_list_get_cursor_pos (_tmp4_);
	_tmp6_ = _tmp5_;
	cursor_pos = _tmp6_;
	_tmp7_ = self->priv->context;
	_tmp8_ = kkc_context_get_candidates (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = kkc_candidate_list_get_page_visible (_tmp9_);
	_tmp11_ = _tmp10_;
	if (_tmp11_) {
		IBusLookupTable* _tmp12_;
		gint _tmp13_;
		KkcContext* _tmp14_;
		KkcCandidateList* _tmp15_;
		KkcCandidateList* _tmp16_;
		guint _tmp17_;
		guint _tmp18_;
		IBusLookupTable* _tmp19_;
		KkcContext* _tmp20_;
		KkcCandidateList* _tmp21_;
		KkcCandidateList* _tmp22_;
		KkcCandidate* _tmp23_ = NULL;
		KkcCandidate* candidate;
		gboolean _tmp24_ = FALSE;
		gboolean _tmp25_;
		gboolean _tmp29_;
		_tmp12_ = self->priv->lookup_table;
		_tmp13_ = cursor_pos;
		_tmp14_ = self->priv->context;
		_tmp15_ = kkc_context_get_candidates (_tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = kkc_candidate_list_get_page_start (_tmp16_);
		_tmp18_ = _tmp17_;
		ibus_lookup_table_set_cursor_pos (_tmp12_, _tmp13_ - _tmp18_);
		_tmp19_ = self->priv->lookup_table;
		ibus_engine_update_lookup_table_fast ((IBusEngine*) self, _tmp19_, TRUE);
		_tmp20_ = self->priv->context;
		_tmp21_ = kkc_context_get_candidates (_tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = kkc_candidate_list_get (_tmp22_, -1);
		candidate = _tmp23_;
		_tmp25_ = self->priv->show_annotation;
		if (_tmp25_) {
			KkcCandidate* _tmp26_;
			const gchar* _tmp27_;
			const gchar* _tmp28_;
			_tmp26_ = candidate;
			_tmp27_ = kkc_candidate_get_annotation (_tmp26_);
			_tmp28_ = _tmp27_;
			_tmp24_ = _tmp28_ != NULL;
		} else {
			_tmp24_ = FALSE;
		}
		_tmp29_ = _tmp24_;
		if (_tmp29_) {
			KkcCandidate* _tmp30_;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
			IBusText* _tmp33_;
			IBusText* _tmp34_;
			IBusText* text;
			IBusText* _tmp35_;
			_tmp30_ = candidate;
			_tmp31_ = kkc_candidate_get_annotation (_tmp30_);
			_tmp32_ = _tmp31_;
			_tmp33_ = ibus_text_new_from_string (_tmp32_);
			_tmp34_ = g_object_ref_sink (_tmp33_);
			text = _tmp34_;
			_tmp35_ = text;
			ibus_engine_update_auxiliary_text ((IBusEngine*) self, _tmp35_, TRUE);
			_g_object_unref0 (text);
		} else {
			IBusText* _tmp36_;
			_tmp36_ = empty_text;
			ibus_engine_update_auxiliary_text ((IBusEngine*) self, _tmp36_, FALSE);
		}
		self->priv->lookup_table_visible = TRUE;
		_g_object_unref0 (candidate);
	} else {
		gboolean _tmp37_;
		_tmp37_ = self->priv->lookup_table_visible;
		if (_tmp37_) {
			ibus_engine_hide_lookup_table ((IBusEngine*) self);
			ibus_engine_hide_auxiliary_text ((IBusEngine*) self);
			self->priv->lookup_table_visible = FALSE;
		}
	}
	_g_object_unref0 (empty_text);
}


static void kkc_engine_update_preedit (KkcEngine* self) {
	IBusText* text = NULL;
	KkcContext* _tmp0_;
	KkcSegmentList* _tmp1_;
	KkcSegmentList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	IBusText* _tmp61_;
	guint _tmp62_ = 0U;
	KkcContext* _tmp66_;
	gboolean _tmp67_ = FALSE;
	IBusText* _tmp74_;
	IBusText* _tmp75_;
	guint _tmp76_ = 0U;
	IBusText* _tmp77_;
	guint _tmp78_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_get_segments (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = kkc_segment_list_get_cursor_pos (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ >= 0) {
		KkcContext* _tmp5_;
		KkcSegmentList* _tmp6_;
		KkcSegmentList* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		IBusText* _tmp10_;
		IBusText* _tmp11_;
		gint index;
		gint offset;
		IBusText* _tmp31_;
		gint _tmp32_;
		gint _tmp33_;
		KkcContext* _tmp34_;
		KkcSegmentList* _tmp35_;
		KkcSegmentList* _tmp36_;
		gint _tmp37_;
		KkcSegment* _tmp38_ = NULL;
		KkcSegment* _tmp39_;
		const gchar* _tmp40_;
		const gchar* _tmp41_;
		gint _tmp42_ = 0;
		IBusText* _tmp43_;
		gint _tmp44_;
		gint _tmp45_;
		KkcContext* _tmp46_;
		KkcSegmentList* _tmp47_;
		KkcSegmentList* _tmp48_;
		gint _tmp49_;
		KkcSegment* _tmp50_ = NULL;
		KkcSegment* _tmp51_;
		const gchar* _tmp52_;
		const gchar* _tmp53_;
		gint _tmp54_ = 0;
		_tmp5_ = self->priv->context;
		_tmp6_ = kkc_context_get_segments (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = kkc_segment_list_get_output (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = ibus_text_new_from_string (_tmp9_);
		_tmp11_ = g_object_ref_sink (_tmp10_);
		_g_object_unref0 (text);
		text = _tmp11_;
		_g_free0 (_tmp9_);
		index = 0;
		offset = 0;
		{
			gboolean _tmp12_;
			_tmp12_ = TRUE;
			while (TRUE) {
				gboolean _tmp13_;
				gint _tmp15_;
				KkcContext* _tmp16_;
				KkcSegmentList* _tmp17_;
				KkcSegmentList* _tmp18_;
				gint _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				KkcContext* _tmp22_;
				KkcSegmentList* _tmp23_;
				KkcSegmentList* _tmp24_;
				gint _tmp25_;
				KkcSegment* _tmp26_ = NULL;
				KkcSegment* _tmp27_;
				const gchar* _tmp28_;
				const gchar* _tmp29_;
				gint _tmp30_ = 0;
				_tmp13_ = _tmp12_;
				if (!_tmp13_) {
					gint _tmp14_;
					_tmp14_ = index;
					index = _tmp14_ + 1;
				}
				_tmp12_ = FALSE;
				_tmp15_ = index;
				_tmp16_ = self->priv->context;
				_tmp17_ = kkc_context_get_segments (_tmp16_);
				_tmp18_ = _tmp17_;
				_tmp19_ = kkc_segment_list_get_cursor_pos (_tmp18_);
				_tmp20_ = _tmp19_;
				if (!(_tmp15_ < _tmp20_)) {
					break;
				}
				_tmp21_ = offset;
				_tmp22_ = self->priv->context;
				_tmp23_ = kkc_context_get_segments (_tmp22_);
				_tmp24_ = _tmp23_;
				_tmp25_ = index;
				_tmp26_ = kkc_segment_list_get (_tmp24_, _tmp25_);
				_tmp27_ = _tmp26_;
				_tmp28_ = kkc_segment_get_output (_tmp27_);
				_tmp29_ = _tmp28_;
				_tmp30_ = g_utf8_strlen (_tmp29_, (gssize) (-1));
				offset = _tmp21_ + _tmp30_;
				_g_object_unref0 (_tmp27_);
			}
		}
		_tmp31_ = text;
		_tmp32_ = offset;
		_tmp33_ = offset;
		_tmp34_ = self->priv->context;
		_tmp35_ = kkc_context_get_segments (_tmp34_);
		_tmp36_ = _tmp35_;
		_tmp37_ = index;
		_tmp38_ = kkc_segment_list_get (_tmp36_, _tmp37_);
		_tmp39_ = _tmp38_;
		_tmp40_ = kkc_segment_get_output (_tmp39_);
		_tmp41_ = _tmp40_;
		_tmp42_ = g_utf8_strlen (_tmp41_, (gssize) (-1));
		ibus_text_append_attribute (_tmp31_, (guint) IBUS_ATTR_TYPE_BACKGROUND, (guint) 0x00aaaaaa, (guint) _tmp32_, _tmp33_ + _tmp42_);
		_g_object_unref0 (_tmp39_);
		_tmp43_ = text;
		_tmp44_ = offset;
		_tmp45_ = offset;
		_tmp46_ = self->priv->context;
		_tmp47_ = kkc_context_get_segments (_tmp46_);
		_tmp48_ = _tmp47_;
		_tmp49_ = index;
		_tmp50_ = kkc_segment_list_get (_tmp48_, _tmp49_);
		_tmp51_ = _tmp50_;
		_tmp52_ = kkc_segment_get_output (_tmp51_);
		_tmp53_ = _tmp52_;
		_tmp54_ = g_utf8_strlen (_tmp53_, (gssize) (-1));
		ibus_text_append_attribute (_tmp43_, (guint) IBUS_ATTR_TYPE_FOREGROUND, (guint) 0x00000000, (guint) _tmp44_, _tmp45_ + _tmp54_);
		_g_object_unref0 (_tmp51_);
	} else {
		KkcContext* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
		IBusText* _tmp59_;
		IBusText* _tmp60_;
		_tmp55_ = self->priv->context;
		_tmp56_ = kkc_context_get_input (_tmp55_);
		_tmp57_ = _tmp56_;
		_tmp58_ = _tmp57_;
		_tmp59_ = ibus_text_new_from_string (_tmp58_);
		_tmp60_ = g_object_ref_sink (_tmp59_);
		_g_object_unref0 (text);
		text = _tmp60_;
		_g_free0 (_tmp58_);
	}
	_tmp61_ = text;
	_tmp62_ = ibus_text_get_length (_tmp61_);
	if (_tmp62_ > ((guint) 0)) {
		IBusText* _tmp63_;
		IBusText* _tmp64_;
		guint _tmp65_ = 0U;
		_tmp63_ = text;
		_tmp64_ = text;
		_tmp65_ = ibus_text_get_length (_tmp64_);
		ibus_text_append_attribute (_tmp63_, (guint) IBUS_ATTR_TYPE_UNDERLINE, (guint) IBUS_ATTR_UNDERLINE_SINGLE, (guint) 0, (gint) _tmp65_);
	}
	_tmp66_ = self->priv->context;
	_tmp67_ = kkc_context_has_output (_tmp66_);
	if (_tmp67_) {
		KkcContext* _tmp68_;
		gchar* _tmp69_ = NULL;
		gchar* output;
		const gchar* _tmp70_;
		IBusText* _tmp71_;
		IBusText* _tmp72_;
		IBusText* ctext;
		IBusText* _tmp73_;
		_tmp68_ = self->priv->context;
		_tmp69_ = kkc_context_poll_output (_tmp68_);
		output = _tmp69_;
		_tmp70_ = output;
		_tmp71_ = ibus_text_new_from_string (_tmp70_);
		_tmp72_ = g_object_ref_sink (_tmp71_);
		ctext = _tmp72_;
		_tmp73_ = ctext;
		ibus_engine_commit_text ((IBusEngine*) self, _tmp73_);
		_g_object_unref0 (ctext);
		_g_free0 (output);
	}
	_tmp74_ = text;
	_tmp75_ = text;
	_tmp76_ = ibus_text_get_length (_tmp75_);
	_tmp77_ = text;
	_tmp78_ = ibus_text_get_length (_tmp77_);
	ibus_engine_update_preedit_text ((IBusEngine*) self, _tmp74_, _tmp76_, _tmp78_ > ((guint) 0));
	_g_object_unref0 (text);
}


static void kkc_engine_update_candidates (KkcEngine* self) {
	KkcContext* _tmp0_;
	KkcCandidateList* _tmp1_;
	KkcCandidateList* _tmp2_;
	guint _tmp3_;
	KkcContext* _tmp4_;
	KkcCandidateList* _tmp5_;
	KkcCandidateList* _tmp6_;
	IBusLookupTable* _tmp7_;
	guint _tmp8_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_get_candidates (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->page_start;
	kkc_candidate_list_set_page_start (_tmp2_, _tmp3_);
	_tmp4_ = self->priv->context;
	_tmp5_ = kkc_context_get_candidates (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = self->priv->lookup_table;
	_tmp8_ = ibus_lookup_table_get_page_size (_tmp7_);
	kkc_candidate_list_set_page_size (_tmp6_, _tmp8_);
	kkc_engine_populate_lookup_table (self);
	kkc_engine_set_lookup_table_cursor_pos (self);
}


static void kkc_engine_update_input_mode (KkcEngine* self) {
	GeeMap* _tmp11_;
	KkcContext* _tmp12_;
	KkcInputMode _tmp13_;
	KkcInputMode _tmp14_;
	gpointer _tmp15_ = NULL;
	IBusProperty* prop;
	GeeMap* _tmp16_;
	KkcContext* _tmp17_;
	KkcInputMode _tmp18_;
	KkcInputMode _tmp19_;
	gpointer _tmp20_ = NULL;
	gchar* _tmp21_;
	IBusText* _tmp22_;
	IBusText* _tmp23_;
	IBusText* _tmp24_;
	IBusText* symbol;
	IBusProperty* _tmp25_;
	IBusProperty* _tmp26_;
	g_return_if_fail (self != NULL);
	{
		GeeMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _prop_it;
		_tmp0_ = self->priv->input_mode_props;
		_tmp1_ = gee_map_get_values (_tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_prop_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			IBusProperty* prop;
			IBusProperty* _tmp10_;
			_tmp6_ = _prop_it;
			_tmp7_ = gee_iterator_next (_tmp6_);
			if (!_tmp7_) {
				break;
			}
			_tmp8_ = _prop_it;
			_tmp9_ = gee_iterator_get (_tmp8_);
			prop = (IBusProperty*) _tmp9_;
			_tmp10_ = prop;
			ibus_property_set_state (_tmp10_, PROP_STATE_UNCHECKED);
			_g_object_unref0 (prop);
		}
		_g_object_unref0 (_prop_it);
	}
	_tmp11_ = self->priv->input_mode_props;
	_tmp12_ = self->priv->context;
	_tmp13_ = kkc_context_get_input_mode (_tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = gee_map_get (_tmp11_, GINT_TO_POINTER (_tmp14_));
	prop = (IBusProperty*) _tmp15_;
	ibus_property_set_state (prop, PROP_STATE_CHECKED);
	ibus_engine_update_property ((IBusEngine*) self, prop);
	_tmp16_ = self->priv->input_mode_symbols;
	_tmp17_ = self->priv->context;
	_tmp18_ = kkc_context_get_input_mode (_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = gee_map_get (_tmp16_, GINT_TO_POINTER (_tmp19_));
	_tmp21_ = (gchar*) _tmp20_;
	_tmp22_ = ibus_text_new_from_string (_tmp21_);
	_tmp23_ = g_object_ref_sink (_tmp22_);
	_tmp24_ = _tmp23_;
	_g_free0 (_tmp21_);
	symbol = _tmp24_;
	_tmp25_ = self->priv->input_mode_prop;
	ibus_property_set_label (_tmp25_, symbol);
	_tmp26_ = self->priv->input_mode_prop;
	ibus_engine_update_property ((IBusEngine*) self, _tmp26_);
	_g_object_unref0 (symbol);
	_g_object_unref0 (prop);
}


static KkcDictionary* kkc_engine_parse_dict_from_plist (PList* plist, GError** error) {
	KkcDictionary* result = NULL;
	PList* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* encoding;
	PList* _tmp7_;
	gchar* _tmp8_ = NULL;
	gchar* type;
	const gchar* _tmp9_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (plist != NULL, NULL);
	_tmp0_ = plist;
	_tmp1_ = plist_get (_tmp0_, "encoding");
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	if (_tmp3_ == NULL) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup ("EUC-JP");
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp4_;
	}
	_tmp5_ = _tmp2_;
	_tmp6_ = g_strdup (_tmp5_);
	encoding = _tmp6_;
	_tmp7_ = plist;
	_tmp8_ = plist_get (_tmp7_, "type");
	type = _tmp8_;
	_tmp9_ = type;
	if (g_strcmp0 (_tmp9_, "file") == 0) {
		PList* _tmp10_;
		gchar* _tmp11_ = NULL;
		gchar* file;
		const gchar* _tmp12_;
		PList* _tmp13_;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* mode;
		const gchar* _tmp20_;
		_tmp10_ = plist;
		_tmp11_ = plist_get (_tmp10_, "file");
		file = _tmp11_;
		_tmp12_ = file;
		if (_tmp12_ == NULL) {
			result = NULL;
			_g_free0 (file);
			_g_free0 (type);
			_g_free0 (encoding);
			_g_free0 (_tmp2_);
			return result;
		}
		_tmp13_ = plist;
		_tmp14_ = plist_get (_tmp13_, "mode");
		_tmp15_ = _tmp14_;
		_tmp16_ = _tmp15_;
		if (_tmp16_ == NULL) {
			gchar* _tmp17_;
			_tmp17_ = g_strdup ("readonly");
			_g_free0 (_tmp15_);
			_tmp15_ = _tmp17_;
		}
		_tmp18_ = _tmp15_;
		_tmp19_ = g_strdup (_tmp18_);
		mode = _tmp19_;
		_tmp20_ = mode;
		if (g_strcmp0 (_tmp20_, "readonly") == 0) {
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			KkcSystemSegmentDictionary* _tmp23_;
			KkcSystemSegmentDictionary* _tmp24_;
			_tmp21_ = file;
			_tmp22_ = encoding;
			_tmp23_ = kkc_system_segment_dictionary_new (_tmp21_, _tmp22_, &_inner_error_);
			_tmp24_ = _tmp23_;
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (mode);
				_g_free0 (_tmp15_);
				_g_free0 (file);
				_g_free0 (type);
				_g_free0 (encoding);
				_g_free0 (_tmp2_);
				return NULL;
			}
			result = (KkcDictionary*) _tmp24_;
			_g_free0 (mode);
			_g_free0 (_tmp15_);
			_g_free0 (file);
			_g_free0 (type);
			_g_free0 (encoding);
			_g_free0 (_tmp2_);
			return result;
		} else {
			const gchar* _tmp25_;
			_tmp25_ = mode;
			if (g_strcmp0 (_tmp25_, "readwrite") == 0) {
				const gchar* _tmp26_;
				KkcUserDictionary* _tmp27_;
				KkcUserDictionary* _tmp28_;
				_tmp26_ = file;
				_tmp27_ = kkc_user_dictionary_new (_tmp26_, &_inner_error_);
				_tmp28_ = _tmp27_;
				if (_inner_error_ != NULL) {
					g_propagate_error (error, _inner_error_);
					_g_free0 (mode);
					_g_free0 (_tmp15_);
					_g_free0 (file);
					_g_free0 (type);
					_g_free0 (encoding);
					_g_free0 (_tmp2_);
					return NULL;
				}
				result = (KkcDictionary*) _tmp28_;
				_g_free0 (mode);
				_g_free0 (_tmp15_);
				_g_free0 (file);
				_g_free0 (type);
				_g_free0 (encoding);
				_g_free0 (_tmp2_);
				return result;
			}
		}
		_g_free0 (mode);
		_g_free0 (_tmp15_);
		_g_free0 (file);
	}
	result = NULL;
	_g_free0 (type);
	_g_free0 (encoding);
	_g_free0 (_tmp2_);
	return result;
}


static void kkc_engine_reload_dictionaries (void) {
	GeeArrayList* _tmp0_;
	Preferences* _tmp1_;
	GVariant* _tmp2_ = NULL;
	GVariant* variant;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	size_t _tmp5_;
	gchar** _tmp6_ = NULL;
	gchar** strv;
	gint strv_length1;
	gint _strv_size_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	GError * _inner_error_ = NULL;
	_tmp0_ = kkc_engine_dictionaries;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
	_tmp1_ = kkc_engine_preferences;
	_tmp2_ = preferences_get (_tmp1_, "dictionaries");
	variant = _tmp2_;
	_tmp3_ = variant;
	g_assert (_tmp3_ != NULL);
	_tmp4_ = variant;
	_tmp6_ = g_variant_dup_strv (_tmp4_, &_tmp5_);
	strv = _tmp6_;
	strv_length1 = _tmp5_;
	_strv_size_ = strv_length1;
	_tmp7_ = strv;
	_tmp7__length1 = strv_length1;
	{
		gchar** str_collection = NULL;
		gint str_collection_length1 = 0;
		gint _str_collection_size_ = 0;
		gint str_it = 0;
		str_collection = _tmp7_;
		str_collection_length1 = _tmp7__length1;
		for (str_it = 0; str_it < _tmp7__length1; str_it = str_it + 1) {
			gchar* _tmp8_;
			gchar* str = NULL;
			_tmp8_ = g_strdup (str_collection[str_it]);
			str = _tmp8_;
			{
				{
					const gchar* _tmp9_;
					PList* _tmp10_;
					PList* plist;
					PList* _tmp11_;
					KkcDictionary* _tmp12_ = NULL;
					KkcDictionary* dict;
					KkcDictionary* _tmp13_;
					_tmp9_ = str;
					_tmp10_ = plist_new (_tmp9_, &_inner_error_);
					plist = _tmp10_;
					if (_inner_error_ != NULL) {
						if (_inner_error_->domain == PLIST_PARSE_ERROR) {
							goto __catch0_plist_parse_error;
						}
						goto __catch0_g_error;
					}
					_tmp11_ = plist;
					_tmp12_ = kkc_engine_parse_dict_from_plist (_tmp11_, &_inner_error_);
					dict = _tmp12_;
					if (_inner_error_ != NULL) {
						_g_object_unref0 (plist);
						if (_inner_error_->domain == PLIST_PARSE_ERROR) {
							goto __catch0_plist_parse_error;
						}
						goto __catch0_g_error;
					}
					_tmp13_ = dict;
					if (_tmp13_ != NULL) {
						GeeArrayList* _tmp14_;
						KkcDictionary* _tmp15_;
						_tmp14_ = kkc_engine_dictionaries;
						_tmp15_ = dict;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
					}
					_g_object_unref0 (dict);
					_g_object_unref0 (plist);
				}
				goto __finally0;
				__catch0_plist_parse_error:
				{
					GError* e = NULL;
					const gchar* _tmp16_;
					GError* _tmp17_;
					const gchar* _tmp18_;
					e = _inner_error_;
					_inner_error_ = NULL;
					_tmp16_ = str;
					_tmp17_ = e;
					_tmp18_ = _tmp17_->message;
					g_warning ("engine.vala:323: can't parse plist \"%s\": %s", _tmp16_, _tmp18_);
					_g_error_free0 (e);
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					const gchar* _tmp19_;
					GError* _tmp20_;
					const gchar* _tmp21_;
					e = _inner_error_;
					_inner_error_ = NULL;
					_tmp19_ = str;
					_tmp20_ = e;
					_tmp21_ = _tmp20_->message;
					g_warning ("engine.vala:326: can't open dictionary \"%s\": %s", _tmp19_, _tmp21_);
					_g_error_free0 (e);
				}
				__finally0:
				if (_inner_error_ != NULL) {
					_g_free0 (str);
					strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
					_g_variant_unref0 (variant);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
				_g_free0 (str);
			}
		}
	}
	strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
	_g_variant_unref0 (variant);
}


static void kkc_engine_apply_preferences (KkcEngine* self) {
	GVariant* variant = NULL;
	Preferences* _tmp0_;
	GVariant* _tmp1_ = NULL;
	GVariant* _tmp2_;
	KkcContext* _tmp3_;
	GVariant* _tmp4_;
	gint32 _tmp5_ = 0;
	Preferences* _tmp6_;
	GVariant* _tmp7_ = NULL;
	GVariant* _tmp8_;
	IBusLookupTable* _tmp9_;
	GVariant* _tmp10_;
	gint32 _tmp11_ = 0;
	Preferences* _tmp12_;
	GVariant* _tmp13_ = NULL;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	gint32 _tmp16_ = 0;
	Preferences* _tmp17_;
	GVariant* _tmp18_ = NULL;
	GVariant* _tmp19_;
	KkcContext* _tmp20_;
	GVariant* _tmp21_;
	gint32 _tmp22_ = 0;
	Preferences* _tmp23_;
	GVariant* _tmp24_ = NULL;
	GVariant* _tmp25_;
	GVariant* _tmp26_;
	gboolean _tmp27_ = FALSE;
	Preferences* _tmp28_;
	GVariant* _tmp29_ = NULL;
	GVariant* _tmp30_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = kkc_engine_preferences;
	_tmp1_ = preferences_get (_tmp0_, "punctuation_style");
	_g_variant_unref0 (variant);
	variant = _tmp1_;
	_tmp2_ = variant;
	g_assert (_tmp2_ != NULL);
	_tmp3_ = self->priv->context;
	_tmp4_ = variant;
	_tmp5_ = g_variant_get_int32 (_tmp4_);
	kkc_context_set_punctuation_style (_tmp3_, (KkcPunctuationStyle) _tmp5_);
	_tmp6_ = kkc_engine_preferences;
	_tmp7_ = preferences_get (_tmp6_, "page_size");
	_g_variant_unref0 (variant);
	variant = _tmp7_;
	_tmp8_ = variant;
	g_assert (_tmp8_ != NULL);
	_tmp9_ = self->priv->lookup_table;
	_tmp10_ = variant;
	_tmp11_ = g_variant_get_int32 (_tmp10_);
	ibus_lookup_table_set_page_size (_tmp9_, (guint) _tmp11_);
	_tmp12_ = kkc_engine_preferences;
	_tmp13_ = preferences_get (_tmp12_, "pagination_start");
	_g_variant_unref0 (variant);
	variant = _tmp13_;
	_tmp14_ = variant;
	g_assert (_tmp14_ != NULL);
	_tmp15_ = variant;
	_tmp16_ = g_variant_get_int32 (_tmp15_);
	self->priv->page_start = (guint) _tmp16_;
	_tmp17_ = kkc_engine_preferences;
	_tmp18_ = preferences_get (_tmp17_, "initial_input_mode");
	_g_variant_unref0 (variant);
	variant = _tmp18_;
	_tmp19_ = variant;
	g_assert (_tmp19_ != NULL);
	_tmp20_ = self->priv->context;
	_tmp21_ = variant;
	_tmp22_ = g_variant_get_int32 (_tmp21_);
	kkc_context_set_input_mode (_tmp20_, (KkcInputMode) _tmp22_);
	_tmp23_ = kkc_engine_preferences;
	_tmp24_ = preferences_get (_tmp23_, "show_annotation");
	_g_variant_unref0 (variant);
	variant = _tmp24_;
	_tmp25_ = variant;
	g_assert (_tmp25_ != NULL);
	_tmp26_ = variant;
	_tmp27_ = g_variant_get_boolean (_tmp26_);
	self->priv->show_annotation = _tmp27_;
	_tmp28_ = kkc_engine_preferences;
	_tmp29_ = preferences_get (_tmp28_, "typing_rule");
	_g_variant_unref0 (variant);
	variant = _tmp29_;
	_tmp30_ = variant;
	g_assert (_tmp30_ != NULL);
	{
		GVariant* _tmp31_;
		const gchar* _tmp32_ = NULL;
		KkcRule* _tmp33_;
		KkcRule* _tmp34_;
		KkcContext* _tmp35_;
		KkcRule* _tmp36_;
		_tmp31_ = variant;
		_tmp32_ = g_variant_get_string (_tmp31_, NULL);
		_tmp33_ = kkc_rule_new (_tmp32_, &_inner_error_);
		_tmp34_ = _tmp33_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == KKC_RULE_PARSE_ERROR) {
				goto __catch1_kkc_rule_parse_error;
			}
			_g_variant_unref0 (variant);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp35_ = self->priv->context;
		_tmp36_ = _tmp34_;
		kkc_context_set_typing_rule (_tmp35_, _tmp36_);
		_g_object_unref0 (_tmp36_);
	}
	goto __finally1;
	__catch1_kkc_rule_parse_error:
	{
		GError* e = NULL;
		GVariant* _tmp37_;
		const gchar* _tmp38_ = NULL;
		GError* _tmp39_;
		const gchar* _tmp40_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp37_ = variant;
		_tmp38_ = g_variant_get_string (_tmp37_, NULL);
		_tmp39_ = e;
		_tmp40_ = _tmp39_->message;
		g_warning ("engine.vala:360: can't load typing rule %s: %s", _tmp38_, _tmp40_);
		_g_error_free0 (e);
	}
	__finally1:
	if (_inner_error_ != NULL) {
		_g_variant_unref0 (variant);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_variant_unref0 (variant);
}


static IBusProperty* kkc_engine_register_input_mode_property (KkcEngine* self, KkcInputMode mode, const gchar* name, const gchar* label, const gchar* symbol) {
	IBusProperty* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	IBusText* _tmp2_;
	IBusText* _tmp3_;
	IBusProperty* _tmp4_;
	IBusProperty* _tmp5_;
	IBusProperty* _tmp6_;
	IBusProperty* prop;
	GeeMap* _tmp7_;
	KkcInputMode _tmp8_;
	GeeMap* _tmp9_;
	KkcInputMode _tmp10_;
	const gchar* _tmp11_;
	GeeMap* _tmp12_;
	const gchar* _tmp13_;
	KkcInputMode _tmp14_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (label != NULL, NULL);
	g_return_val_if_fail (symbol != NULL, NULL);
	_tmp0_ = name;
	_tmp1_ = label;
	_tmp2_ = ibus_text_new_from_string (_tmp1_);
	_tmp3_ = g_object_ref_sink (_tmp2_);
	_tmp4_ = ibus_property_new (_tmp0_, PROP_TYPE_RADIO, _tmp3_, NULL, NULL, TRUE, TRUE, PROP_STATE_UNCHECKED, NULL);
	_tmp5_ = g_object_ref_sink (_tmp4_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp3_);
	prop = _tmp6_;
	_tmp7_ = self->priv->input_mode_props;
	_tmp8_ = mode;
	gee_map_set (_tmp7_, GINT_TO_POINTER (_tmp8_), prop);
	_tmp9_ = self->priv->input_mode_symbols;
	_tmp10_ = mode;
	_tmp11_ = symbol;
	gee_map_set (_tmp9_, GINT_TO_POINTER (_tmp10_), _tmp11_);
	_tmp12_ = self->priv->name_input_modes;
	_tmp13_ = name;
	_tmp14_ = mode;
	gee_map_set (_tmp12_, _tmp13_, GINT_TO_POINTER (_tmp14_));
	result = prop;
	return result;
}


static gchar* g_unichar_to_string (gunichar self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* str;
	const gchar* _tmp1_;
	_tmp0_ = g_new0 (gchar, 7);
	str = (gchar*) _tmp0_;
	_tmp1_ = str;
	g_unichar_to_utf8 (self, _tmp1_);
	result = str;
	return result;
}


static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle) {
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}


static gboolean kkc_engine_process_lookup_table_key_event (KkcEngine* self, guint keyval, guint keycode, guint state) {
	gboolean result = FALSE;
	IBusLookupTable* _tmp0_;
	guint _tmp1_ = 0U;
	guint page_size;
	gboolean _tmp2_ = FALSE;
	guint _tmp3_;
	gboolean _tmp8_;
	guint _tmp28_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->lookup_table;
	_tmp1_ = ibus_lookup_table_get_page_size (_tmp0_);
	page_size = _tmp1_;
	_tmp3_ = state;
	if (_tmp3_ == ((guint) 0)) {
		guint _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		_tmp4_ = keyval;
		_tmp5_ = g_unichar_to_string ((gunichar) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = self->priv->LOOKUP_TABLE_LABELS;
		_tmp7__length1 = self->priv->LOOKUP_TABLE_LABELS_length1;
		_tmp2_ = _vala_string_array_contains (_tmp7_, _tmp7__length1, _tmp6_);
		_g_free0 (_tmp6_);
	} else {
		_tmp2_ = FALSE;
	}
	_tmp8_ = _tmp2_;
	if (_tmp8_) {
		guint _tmp9_;
		gunichar _tmp10_ = 0U;
		gchar* _tmp11_ = NULL;
		gchar* label;
		_tmp9_ = keyval;
		_tmp10_ = g_unichar_tolower ((gunichar) _tmp9_);
		_tmp11_ = g_unichar_to_string (_tmp10_);
		label = _tmp11_;
		{
			gint index;
			index = 0;
			{
				gboolean _tmp12_;
				_tmp12_ = TRUE;
				while (TRUE) {
					gboolean _tmp13_;
					gint _tmp15_;
					guint _tmp16_;
					gchar** _tmp17_;
					gint _tmp17__length1;
					gint _tmp18_ = 0;
					gchar** _tmp19_;
					gint _tmp19__length1;
					gint _tmp20_;
					const gchar* _tmp21_;
					const gchar* _tmp22_;
					_tmp13_ = _tmp12_;
					if (!_tmp13_) {
						gint _tmp14_;
						_tmp14_ = index;
						index = _tmp14_ + 1;
					}
					_tmp12_ = FALSE;
					_tmp15_ = index;
					_tmp16_ = page_size;
					_tmp17_ = self->priv->LOOKUP_TABLE_LABELS;
					_tmp17__length1 = self->priv->LOOKUP_TABLE_LABELS_length1;
					_tmp18_ = MIN ((gint) _tmp16_, _tmp17__length1);
					if (!(_tmp15_ < _tmp18_)) {
						break;
					}
					_tmp19_ = self->priv->LOOKUP_TABLE_LABELS;
					_tmp19__length1 = self->priv->LOOKUP_TABLE_LABELS_length1;
					_tmp20_ = index;
					_tmp21_ = _tmp19_[_tmp20_];
					_tmp22_ = label;
					if (g_strcmp0 (_tmp21_, _tmp22_) == 0) {
						KkcContext* _tmp23_;
						KkcCandidateList* _tmp24_;
						KkcCandidateList* _tmp25_;
						gint _tmp26_;
						gboolean _tmp27_ = FALSE;
						_tmp23_ = self->priv->context;
						_tmp24_ = kkc_context_get_candidates (_tmp23_);
						_tmp25_ = _tmp24_;
						_tmp26_ = index;
						_tmp27_ = kkc_candidate_list_select_at (_tmp25_, (guint) _tmp26_);
						result = _tmp27_;
						_g_free0 (label);
						return result;
					}
				}
			}
		}
		result = FALSE;
		_g_free0 (label);
		return result;
	}
	_tmp28_ = state;
	if (_tmp28_ == ((guint) 0)) {
		gboolean retval;
		guint _tmp29_;
		gboolean _tmp46_;
		retval = FALSE;
		_tmp29_ = keyval;
		switch (_tmp29_) {
			case IBUS_Page_Up:
			case IBUS_KP_Page_Up:
			{
				KkcContext* _tmp30_;
				KkcCandidateList* _tmp31_;
				KkcCandidateList* _tmp32_;
				gboolean _tmp33_ = FALSE;
				_tmp30_ = self->priv->context;
				_tmp31_ = kkc_context_get_candidates (_tmp30_);
				_tmp32_ = _tmp31_;
				_tmp33_ = kkc_candidate_list_page_up (_tmp32_);
				retval = _tmp33_;
				break;
			}
			case IBUS_Page_Down:
			case IBUS_KP_Page_Down:
			{
				KkcContext* _tmp34_;
				KkcCandidateList* _tmp35_;
				KkcCandidateList* _tmp36_;
				gboolean _tmp37_ = FALSE;
				_tmp34_ = self->priv->context;
				_tmp35_ = kkc_context_get_candidates (_tmp34_);
				_tmp36_ = _tmp35_;
				_tmp37_ = kkc_candidate_list_page_down (_tmp36_);
				retval = _tmp37_;
				break;
			}
			case IBUS_Up:
			{
				KkcContext* _tmp38_;
				KkcCandidateList* _tmp39_;
				KkcCandidateList* _tmp40_;
				gboolean _tmp41_ = FALSE;
				_tmp38_ = self->priv->context;
				_tmp39_ = kkc_context_get_candidates (_tmp38_);
				_tmp40_ = _tmp39_;
				_tmp41_ = kkc_candidate_list_cursor_up (_tmp40_);
				retval = _tmp41_;
				break;
			}
			case IBUS_Down:
			{
				KkcContext* _tmp42_;
				KkcCandidateList* _tmp43_;
				KkcCandidateList* _tmp44_;
				gboolean _tmp45_ = FALSE;
				_tmp42_ = self->priv->context;
				_tmp43_ = kkc_context_get_candidates (_tmp42_);
				_tmp44_ = _tmp43_;
				_tmp45_ = kkc_candidate_list_cursor_down (_tmp44_);
				retval = _tmp45_;
				break;
			}
			default:
			{
				break;
			}
		}
		_tmp46_ = retval;
		if (_tmp46_) {
			kkc_engine_set_lookup_table_cursor_pos (self);
			kkc_engine_update_preedit (self);
			result = TRUE;
			return result;
		}
	}
	result = FALSE;
	return result;
}


static gboolean kkc_engine_real_process_key_event (IBusEngine* base, guint keyval, guint keycode, guint state) {
	KkcEngine * self;
	gboolean result = FALSE;
	guint _tmp0_;
	guint _state;
	gboolean _tmp1_ = FALSE;
	KkcContext* _tmp2_;
	KkcCandidateList* _tmp3_;
	KkcCandidateList* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp11_;
	guint _tmp12_;
	KkcModifierType modifiers;
	KkcKeyEvent* key = NULL;
	KkcContext* _tmp17_;
	KkcKeyEvent* _tmp18_;
	gboolean _tmp19_ = FALSE;
	gboolean retval;
	GError * _inner_error_ = NULL;
	self = (KkcEngine*) base;
	_tmp0_ = state;
	_state = _tmp0_ & ((((IBUS_SHIFT_MASK | IBUS_CONTROL_MASK) | IBUS_MOD1_MASK) | IBUS_MOD5_MASK) | IBUS_RELEASE_MASK);
	_tmp2_ = self->priv->context;
	_tmp3_ = kkc_context_get_candidates (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = kkc_candidate_list_get_page_visible (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_) {
		guint _tmp7_;
		guint _tmp8_;
		guint _tmp9_;
		gboolean _tmp10_ = FALSE;
		_tmp7_ = keyval;
		_tmp8_ = keycode;
		_tmp9_ = _state;
		_tmp10_ = kkc_engine_process_lookup_table_key_event (self, _tmp7_, _tmp8_, _tmp9_);
		_tmp1_ = _tmp10_;
	} else {
		_tmp1_ = FALSE;
	}
	_tmp11_ = _tmp1_;
	if (_tmp11_) {
		result = TRUE;
		return result;
	}
	_tmp12_ = _state;
	modifiers = (KkcModifierType) _tmp12_;
	{
		guint _tmp13_;
		KkcModifierType _tmp14_;
		KkcKeyEvent* _tmp15_;
		KkcKeyEvent* _tmp16_;
		_tmp13_ = keyval;
		_tmp14_ = modifiers;
		_tmp15_ = kkc_key_event_new_from_x_keysym (_tmp13_, _tmp14_, &_inner_error_);
		_tmp16_ = _tmp15_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == KKC_KEY_EVENT_FORMAT_ERROR) {
				goto __catch2_kkc_key_event_format_error;
			}
			_g_object_unref0 (key);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_g_object_unref0 (key);
		key = _tmp16_;
	}
	goto __finally2;
	__catch2_kkc_key_event_format_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		result = FALSE;
		_g_error_free0 (e);
		_g_object_unref0 (key);
		return result;
	}
	__finally2:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (key);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	_tmp17_ = self->priv->context;
	_tmp18_ = key;
	_tmp19_ = kkc_context_process_key_event (_tmp17_, _tmp18_);
	retval = _tmp19_;
	{
		KkcEngineKeyEntry* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
		entry_collection = KKC_ENGINE_IGNORE_KEYS;
		entry_collection_length1 = G_N_ELEMENTS (KKC_ENGINE_IGNORE_KEYS);
		for (entry_it = 0; entry_it < G_N_ELEMENTS (KKC_ENGINE_IGNORE_KEYS); entry_it = entry_it + 1) {
			KkcEngineKeyEntry entry = {0};
			entry = entry_collection[entry_it];
			{
				gboolean _tmp20_ = FALSE;
				KkcEngineKeyEntry _tmp21_;
				guint _tmp22_;
				guint _tmp23_;
				gboolean _tmp27_;
				_tmp21_ = entry;
				_tmp22_ = _tmp21_.keyval;
				_tmp23_ = keyval;
				if (_tmp22_ == _tmp23_) {
					KkcEngineKeyEntry _tmp24_;
					guint _tmp25_;
					KkcModifierType _tmp26_;
					_tmp24_ = entry;
					_tmp25_ = _tmp24_.modifiers;
					_tmp26_ = modifiers;
					_tmp20_ = _tmp25_ == ((guint) _tmp26_);
				} else {
					_tmp20_ = FALSE;
				}
				_tmp27_ = _tmp20_;
				if (_tmp27_) {
					result = TRUE;
					_g_object_unref0 (key);
					return result;
				}
			}
		}
	}
	result = retval;
	_g_object_unref0 (key);
	return result;
}


static gboolean __lambda2_ (KkcEngine* self) {
	gboolean result = FALSE;
	KkcContext* _tmp0_;
	KkcDictionaryList* _tmp1_;
	KkcDictionaryList* _tmp2_;
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_get_dictionaries (_tmp0_);
	_tmp2_ = _tmp1_;
	kkc_dictionary_list_save (_tmp2_);
	result = TRUE;
	return result;
}


static gboolean ___lambda2__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda2_ (self);
	return result;
}


static void kkc_engine_real_enable (IBusEngine* base) {
	KkcEngine * self;
	KkcContext* _tmp0_;
	guint _tmp1_ = 0U;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	kkc_context_reset (_tmp0_);
	_tmp1_ = g_timeout_add_seconds_full (G_PRIORITY_LOW, (guint) 300, ___lambda2__gsource_func, g_object_ref (self), g_object_unref);
	self->priv->save_dictionaries_timeout_id = _tmp1_;
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->enable (IBUS_ENGINE (self));
}


static void kkc_engine_real_disable (IBusEngine* base) {
	KkcEngine * self;
	guint _tmp0_;
	KkcContext* _tmp2_;
	KkcDictionaryList* _tmp3_;
	KkcDictionaryList* _tmp4_;
	self = (KkcEngine*) base;
	g_signal_emit_by_name ((IBusEngine*) self, "focus-out");
	_tmp0_ = self->priv->save_dictionaries_timeout_id;
	if (_tmp0_ > ((guint) 0)) {
		guint _tmp1_;
		_tmp1_ = self->priv->save_dictionaries_timeout_id;
		g_source_remove (_tmp1_);
		self->priv->save_dictionaries_timeout_id = (guint) 0;
	}
	_tmp2_ = self->priv->context;
	_tmp3_ = kkc_context_get_dictionaries (_tmp2_);
	_tmp4_ = _tmp3_;
	kkc_dictionary_list_save (_tmp4_);
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->disable (IBUS_ENGINE (self));
}


static void kkc_engine_real_reset (IBusEngine* base) {
	KkcEngine * self;
	KkcContext* _tmp0_;
	IBusText* _tmp1_;
	IBusText* _tmp2_;
	IBusText* empty_text;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	kkc_context_reset (_tmp0_);
	_tmp1_ = ibus_text_new_from_static_string ("");
	_tmp2_ = g_object_ref_sink (_tmp1_);
	empty_text = _tmp2_;
	ibus_engine_update_preedit_text ((IBusEngine*) self, empty_text, (guint) 0, FALSE);
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->reset (IBUS_ENGINE (self));
	_g_object_unref0 (empty_text);
}


static void kkc_engine_real_focus_in (IBusEngine* base) {
	KkcEngine * self;
	IBusPropList* _tmp0_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->prop_list;
	ibus_engine_register_properties ((IBusEngine*) self, _tmp0_);
	kkc_engine_update_input_mode (self);
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->focus_in (IBUS_ENGINE (self));
}


static void kkc_engine_real_focus_out (IBusEngine* base) {
	KkcEngine * self;
	KkcContext* _tmp0_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	kkc_context_reset (_tmp0_);
	ibus_engine_hide_preedit_text ((IBusEngine*) self);
	ibus_engine_hide_lookup_table ((IBusEngine*) self);
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->focus_out (IBUS_ENGINE (self));
}


static void kkc_engine_real_property_activate (IBusEngine* base, const gchar* prop_name, guint prop_state) {
	KkcEngine * self;
	const gchar* _tmp0_;
	GError * _inner_error_ = NULL;
	self = (KkcEngine*) base;
	g_return_if_fail (prop_name != NULL);
	_tmp0_ = prop_name;
	if (g_strcmp0 (_tmp0_, "setup") == 0) {
		gchar* _tmp1_ = NULL;
		gchar* filename;
		_tmp1_ = g_build_filename (LIBEXECDIR, "ibus-setup-kkc", NULL);
		filename = _tmp1_;
		{
			const gchar* _tmp2_;
			_tmp2_ = filename;
			g_spawn_command_line_async (_tmp2_, &_inner_error_);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_SPAWN_ERROR) {
					goto __catch3_g_spawn_error;
				}
				_g_free0 (filename);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		goto __finally3;
		__catch3_g_spawn_error:
		{
			GError* e = NULL;
			const gchar* _tmp3_;
			GError* _tmp4_;
			const gchar* _tmp5_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp3_ = filename;
			_tmp4_ = e;
			_tmp5_ = _tmp4_->message;
			g_warning ("engine.vala:539: can't spawn %s: %s", _tmp3_, _tmp5_);
			_g_error_free0 (e);
		}
		__finally3:
		if (_inner_error_ != NULL) {
			_g_free0 (filename);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_g_free0 (filename);
	} else {
		gboolean _tmp6_ = FALSE;
		const gchar* _tmp7_;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp10_;
		_tmp7_ = prop_name;
		_tmp8_ = g_str_has_prefix (_tmp7_, "InputMode.");
		if (_tmp8_) {
			guint _tmp9_;
			_tmp9_ = prop_state;
			_tmp6_ = _tmp9_ == ((guint) PROP_STATE_CHECKED);
		} else {
			_tmp6_ = FALSE;
		}
		_tmp10_ = _tmp6_;
		if (_tmp10_) {
			KkcContext* _tmp11_;
			GeeMap* _tmp12_;
			const gchar* _tmp13_;
			gpointer _tmp14_ = NULL;
			_tmp11_ = self->priv->context;
			_tmp12_ = self->priv->name_input_modes;
			_tmp13_ = prop_name;
			_tmp14_ = gee_map_get (_tmp12_, _tmp13_);
			kkc_context_set_input_mode (_tmp11_, GPOINTER_TO_INT (_tmp14_));
		}
	}
}


static void __lambda3_ (void) {
	ibus_quit ();
}


static void ___lambda3__ibus_bus_disconnected (IBusBus* _sender, gpointer self) {
	__lambda3_ ();
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void __lambda4_ (const gchar* name, GVariant* value) {
	const gchar* _tmp0_;
	g_return_if_fail (name != NULL);
	g_return_if_fail (value != NULL);
	_tmp0_ = name;
	if (g_strcmp0 (_tmp0_, "dictionaries") == 0) {
		kkc_engine_reload_dictionaries ();
	}
}


static void ___lambda4__preferences_value_changed (Preferences* _sender, const gchar* name, GVariant* value, gpointer self) {
	__lambda4_ (name, value);
}


gint kkc_engine_main (gchar** args, int args_length1) {
	gint result = 0;
	GOptionContext* _tmp0_;
	GOptionContext* context;
	GOptionContext* _tmp1_;
	IBusBus* _tmp6_;
	IBusBus* _tmp7_;
	IBusBus* bus;
	IBusBus* _tmp8_;
	gboolean _tmp9_ = FALSE;
	IBusBus* _tmp11_;
	IBusBus* _tmp12_;
	IBusConfig* _tmp13_ = NULL;
	IBusConfig* _tmp14_;
	IBusConfig* config;
	IBusConfig* _tmp15_;
	Preferences* _tmp16_;
	GeeArrayList* _tmp17_;
	Preferences* _tmp18_;
	IBusBus* _tmp19_;
	GDBusConnection* _tmp20_ = NULL;
	IBusFactory* _tmp21_;
	IBusFactory* _tmp22_;
	IBusFactory* factory;
	IBusFactory* _tmp23_;
	gboolean _tmp24_;
	GError * _inner_error_ = NULL;
	ibus_init ();
	kkc_init ();
	gtk_init (&args_length1, &args);
	setlocale (LC_ALL, "");
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	_tmp0_ = g_option_context_new ("- ibus kkc");
	context = _tmp0_;
	_tmp1_ = context;
	g_option_context_add_main_entries (_tmp1_, KKC_ENGINE_options, "ibus-kkc");
	{
		GOptionContext* _tmp2_;
		_tmp2_ = context;
		g_option_context_parse (_tmp2_, &args_length1, &args, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_OPTION_ERROR) {
				goto __catch4_g_option_error;
			}
			_g_option_context_free0 (context);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0;
		}
	}
	goto __finally4;
	__catch4_g_option_error:
	{
		GError* e = NULL;
		FILE* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = stderr;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		fprintf (_tmp3_, "%s\n", _tmp5_);
		result = 1;
		_g_error_free0 (e);
		_g_option_context_free0 (context);
		return result;
	}
	__finally4:
	if (_inner_error_ != NULL) {
		_g_option_context_free0 (context);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
	_tmp6_ = ibus_bus_new ();
	_tmp7_ = g_object_ref_sink (_tmp6_);
	bus = _tmp7_;
	_tmp8_ = bus;
	_tmp9_ = ibus_bus_is_connected (_tmp8_);
	if (!_tmp9_) {
		FILE* _tmp10_;
		_tmp10_ = stderr;
		fprintf (_tmp10_, "cannot connect to ibus-daemon!\n");
		result = 1;
		_g_object_unref0 (bus);
		_g_option_context_free0 (context);
		return result;
	}
	_tmp11_ = bus;
	g_signal_connect (_tmp11_, "disconnected", (GCallback) ___lambda3__ibus_bus_disconnected, NULL);
	_tmp12_ = bus;
	_tmp13_ = ibus_bus_get_config (_tmp12_);
	_tmp14_ = _g_object_ref0 (_tmp13_);
	config = _tmp14_;
	_tmp15_ = config;
	_tmp16_ = preferences_new (_tmp15_);
	_g_object_unref0 (kkc_engine_preferences);
	kkc_engine_preferences = _tmp16_;
	_tmp17_ = gee_array_list_new (KKC_TYPE_DICTIONARY, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	_g_object_unref0 (kkc_engine_dictionaries);
	kkc_engine_dictionaries = _tmp17_;
	kkc_engine_reload_dictionaries ();
	_tmp18_ = kkc_engine_preferences;
	g_signal_connect (_tmp18_, "value-changed", (GCallback) ___lambda4__preferences_value_changed, NULL);
	_tmp19_ = bus;
	_tmp20_ = ibus_bus_get_connection (_tmp19_);
	_tmp21_ = ibus_factory_new (_tmp20_);
	_tmp22_ = g_object_ref_sink (_tmp21_);
	factory = _tmp22_;
	_tmp23_ = factory;
	ibus_factory_add_engine (_tmp23_, "kkc", TYPE_KKC_ENGINE);
	_tmp24_ = kkc_engine_ibus;
	if (_tmp24_) {
		IBusBus* _tmp25_;
		_tmp25_ = bus;
		ibus_bus_request_name (_tmp25_, "org.freedesktop.IBus.KKC", (guint32) 0);
	} else {
		IBusComponent* _tmp26_;
		IBusComponent* _tmp27_;
		IBusComponent* component;
		gchar* _tmp28_ = NULL;
		gchar* _tmp29_;
		IBusEngineDesc* _tmp30_;
		IBusEngineDesc* _tmp31_;
		IBusEngineDesc* _tmp32_;
		IBusEngineDesc* engine;
		IBusComponent* _tmp33_;
		IBusEngineDesc* _tmp34_;
		IBusBus* _tmp35_;
		IBusComponent* _tmp36_;
		_tmp26_ = ibus_component_new ("org.freedesktop.IBus.KKC", "Kana Kanji", PACKAGE_VERSION, "GPL", "Daiki Ueno <ueno@gnu.org>", "http://code.google.com/p/ibus/", "", "ibus-kkc");
		_tmp27_ = g_object_ref_sink (_tmp26_);
		component = _tmp27_;
		_tmp28_ = g_strdup_printf ("%s/icons/ibus-kkc.svg", PACKAGE_DATADIR);
		_tmp29_ = _tmp28_;
		_tmp30_ = ibus_engine_desc_new ("kkc", "Kana Kanji", "Kana Kanji Input Method", "ja", "GPL", "Daiki Ueno <ueno@gnu.org>", _tmp29_, "us");
		_tmp31_ = g_object_ref_sink (_tmp30_);
		_tmp32_ = _tmp31_;
		_g_free0 (_tmp29_);
		engine = _tmp32_;
		_tmp33_ = component;
		_tmp34_ = engine;
		ibus_component_add_engine (_tmp33_, _tmp34_);
		_tmp35_ = bus;
		_tmp36_ = component;
		ibus_bus_register_component (_tmp35_, _tmp36_);
		_g_object_unref0 (engine);
		_g_object_unref0 (component);
	}
	ibus_main ();
	result = 0;
	_g_object_unref0 (factory);
	_g_object_unref0 (config);
	_g_object_unref0 (bus);
	_g_option_context_free0 (context);
	return result;
}


int main (int argc, char ** argv) {
	g_type_init ();
	return kkc_engine_main (argv, argc);
}


KkcEngine* kkc_engine_construct (GType object_type) {
	KkcEngine * self = NULL;
	self = (KkcEngine*) g_object_new (object_type, NULL);
	return self;
}


KkcEngine* kkc_engine_new (void) {
	return kkc_engine_construct (TYPE_KKC_ENGINE);
}


static void _kkc_engine___lambda5_ (KkcEngine* self, const gchar* name, GVariant* value) {
	const gchar* _tmp0_;
	g_return_if_fail (name != NULL);
	g_return_if_fail (value != NULL);
	kkc_engine_apply_preferences (self);
	_tmp0_ = name;
	if (g_strcmp0 (_tmp0_, "dictionaries") == 0) {
		KkcContext* _tmp1_;
		KkcDictionaryList* _tmp2_;
		KkcDictionaryList* _tmp3_;
		_tmp1_ = self->priv->context;
		_tmp2_ = kkc_context_get_dictionaries (_tmp1_);
		_tmp3_ = _tmp2_;
		kkc_dictionary_list_clear (_tmp3_);
		{
			GeeArrayList* _tmp4_;
			GeeArrayList* _tmp5_;
			GeeArrayList* _dictionary_list;
			GeeArrayList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _dictionary_size;
			gint _dictionary_index;
			_tmp4_ = kkc_engine_dictionaries;
			_tmp5_ = _g_object_ref0 (_tmp4_);
			_dictionary_list = _tmp5_;
			_tmp6_ = _dictionary_list;
			_tmp7_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp6_);
			_tmp8_ = _tmp7_;
			_dictionary_size = _tmp8_;
			_dictionary_index = -1;
			while (TRUE) {
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				GeeArrayList* _tmp12_;
				gint _tmp13_;
				gpointer _tmp14_ = NULL;
				KkcDictionary* dictionary;
				KkcContext* _tmp15_;
				KkcDictionaryList* _tmp16_;
				KkcDictionaryList* _tmp17_;
				KkcDictionary* _tmp18_;
				_tmp9_ = _dictionary_index;
				_dictionary_index = _tmp9_ + 1;
				_tmp10_ = _dictionary_index;
				_tmp11_ = _dictionary_size;
				if (!(_tmp10_ < _tmp11_)) {
					break;
				}
				_tmp12_ = _dictionary_list;
				_tmp13_ = _dictionary_index;
				_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _tmp13_);
				dictionary = (KkcDictionary*) _tmp14_;
				_tmp15_ = self->priv->context;
				_tmp16_ = kkc_context_get_dictionaries (_tmp15_);
				_tmp17_ = _tmp16_;
				_tmp18_ = dictionary;
				kkc_dictionary_list_add (_tmp17_, _tmp18_);
				_g_object_unref0 (dictionary);
			}
			_g_object_unref0 (_dictionary_list);
		}
	}
}


static void __kkc_engine___lambda5__preferences_value_changed (Preferences* _sender, const gchar* name, GVariant* value, gpointer self) {
	_kkc_engine___lambda5_ (self, name, value);
}


static void _kkc_engine___lambda6_ (KkcEngine* self, const gchar* name, GVariant* value) {
	g_return_if_fail (name != NULL);
	g_return_if_fail (value != NULL);
	kkc_engine_apply_preferences (self);
}


static void __kkc_engine___lambda6__preferences_value_changed (Preferences* _sender, const gchar* name, GVariant* value, gpointer self) {
	_kkc_engine___lambda6_ (self, name, value);
}


static void _kkc_engine___lambda7_ (KkcEngine* self) {
	kkc_engine_update_preedit (self);
}


static void __kkc_engine___lambda7__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	_kkc_engine___lambda7_ (self);
}


static void _kkc_engine___lambda8_ (KkcEngine* self, GObject* s, GParamSpec* p) {
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	kkc_engine_update_input_mode (self);
}


static void __kkc_engine___lambda8__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	_kkc_engine___lambda8_ (self, _sender, pspec);
}


static void _kkc_engine___lambda9_ (KkcEngine* self) {
	kkc_engine_populate_lookup_table (self);
}


static void __kkc_engine___lambda9__kkc_candidate_list_populated (KkcCandidateList* _sender, gpointer self) {
	_kkc_engine___lambda9_ (self);
}


static void _kkc_engine___lambda10_ (KkcEngine* self) {
	kkc_engine_set_lookup_table_cursor_pos (self);
}


static void __kkc_engine___lambda10__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	_kkc_engine___lambda10_ (self);
}


static void _kkc_engine___lambda11_ (KkcEngine* self) {
	gboolean _tmp0_;
	_tmp0_ = self->priv->lookup_table_visible;
	if (_tmp0_) {
		ibus_engine_hide_lookup_table ((IBusEngine*) self);
		ibus_engine_hide_auxiliary_text ((IBusEngine*) self);
		self->priv->lookup_table_visible = FALSE;
	}
}


static void __kkc_engine___lambda11__kkc_candidate_list_selected (KkcCandidateList* _sender, KkcCandidate* candidate, gpointer self) {
	_kkc_engine___lambda11_ (self);
}


static void _kkc_engine___lambda12_ (KkcEngine* self, KkcContext* e) {
	GtkClipboard* _tmp0_;
	g_return_if_fail (e != NULL);
	_tmp0_ = self->priv->clipboard;
	gtk_clipboard_request_text (_tmp0_, (GtkClipboardTextReceivedFunc) kkc_engine_set_selection_text, self);
}


static void __kkc_engine___lambda12__kkc_context_request_selection_text (KkcContext* _sender, gpointer self) {
	_kkc_engine___lambda12_ (self, _sender);
}


static GObject * kkc_engine_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	KkcEngine * self;
	gchar** _tmp0_;
	gint _tmp0__length1;
	IBusLookupTable* _tmp1_;
	IBusLookupTable* _tmp2_;
	IBusPropList* _tmp16_;
	IBusPropList* _tmp17_;
	IBusPropList* _tmp18_;
	IBusPropList* _tmp19_;
	IBusPropList* props;
	IBusProperty* prop = NULL;
	const gchar* _tmp20_ = NULL;
	IBusProperty* _tmp21_ = NULL;
	IBusPropList* _tmp22_;
	IBusProperty* _tmp23_;
	const gchar* _tmp24_ = NULL;
	IBusProperty* _tmp25_ = NULL;
	IBusPropList* _tmp26_;
	IBusProperty* _tmp27_;
	const gchar* _tmp28_ = NULL;
	IBusProperty* _tmp29_ = NULL;
	IBusPropList* _tmp30_;
	IBusProperty* _tmp31_;
	const gchar* _tmp32_ = NULL;
	IBusProperty* _tmp33_ = NULL;
	IBusPropList* _tmp34_;
	IBusProperty* _tmp35_;
	const gchar* _tmp36_ = NULL;
	IBusProperty* _tmp37_ = NULL;
	IBusPropList* _tmp38_;
	IBusProperty* _tmp39_;
	const gchar* _tmp40_ = NULL;
	IBusProperty* _tmp41_ = NULL;
	IBusPropList* _tmp42_;
	IBusProperty* _tmp43_;
	IBusText* _tmp44_;
	IBusText* _tmp45_;
	const gchar* _tmp46_ = NULL;
	IBusText* _tmp47_;
	IBusText* _tmp48_;
	IBusPropList* _tmp49_;
	IBusProperty* _tmp50_;
	IBusProperty* _tmp51_;
	IBusPropList* _tmp52_;
	IBusProperty* _tmp53_;
	IBusProperty* _tmp54_;
	IBusProperty* _tmp55_;
	const gchar* _tmp56_ = NULL;
	IBusText* _tmp57_;
	IBusText* _tmp58_;
	const gchar* _tmp59_ = NULL;
	IBusText* _tmp60_;
	IBusText* _tmp61_;
	IBusProperty* _tmp62_;
	IBusProperty* _tmp63_;
	IBusPropList* _tmp64_;
	IBusProperty* _tmp65_;
	KkcLanguageModel* model = NULL;
	KkcLanguageModel* _tmp70_;
	KkcContext* _tmp71_;
	Preferences* _tmp87_;
	Preferences* _tmp88_;
	KkcContext* _tmp89_;
	KkcContext* _tmp90_;
	KkcContext* _tmp91_;
	KkcCandidateList* _tmp92_;
	KkcCandidateList* _tmp93_;
	KkcContext* _tmp94_;
	KkcCandidateList* _tmp95_;
	KkcCandidateList* _tmp96_;
	KkcContext* _tmp97_;
	KkcCandidateList* _tmp98_;
	KkcCandidateList* _tmp99_;
	GtkClipboard* _tmp100_ = NULL;
	GtkClipboard* _tmp101_;
	KkcContext* _tmp102_;
	GError * _inner_error_ = NULL;
	parent_class = G_OBJECT_CLASS (kkc_engine_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = KKC_ENGINE (obj);
	_tmp0_ = self->priv->LOOKUP_TABLE_LABELS;
	_tmp0__length1 = self->priv->LOOKUP_TABLE_LABELS_length1;
	_tmp1_ = ibus_lookup_table_new ((guint) _tmp0__length1, (guint) 0, TRUE, TRUE);
	_tmp2_ = g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->lookup_table);
	self->priv->lookup_table = _tmp2_;
	{
		gint i;
		i = 0;
		{
			gboolean _tmp3_;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_;
				gint _tmp6_;
				gchar** _tmp7_;
				gint _tmp7__length1;
				gchar** _tmp8_;
				gint _tmp8__length1;
				gint _tmp9_;
				const gchar* _tmp10_;
				IBusText* _tmp11_;
				IBusText* _tmp12_;
				IBusText* text;
				IBusLookupTable* _tmp13_;
				gint _tmp14_;
				IBusText* _tmp15_;
				_tmp4_ = _tmp3_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp6_ = i;
				_tmp7_ = self->priv->LOOKUP_TABLE_LABELS;
				_tmp7__length1 = self->priv->LOOKUP_TABLE_LABELS_length1;
				if (!(_tmp6_ < _tmp7__length1)) {
					break;
				}
				_tmp8_ = self->priv->LOOKUP_TABLE_LABELS;
				_tmp8__length1 = self->priv->LOOKUP_TABLE_LABELS_length1;
				_tmp9_ = i;
				_tmp10_ = _tmp8_[_tmp9_];
				_tmp11_ = ibus_text_new_from_string (_tmp10_);
				_tmp12_ = g_object_ref_sink (_tmp11_);
				text = _tmp12_;
				_tmp13_ = self->priv->lookup_table;
				_tmp14_ = i;
				_tmp15_ = text;
				ibus_lookup_table_set_label (_tmp13_, (guint) _tmp14_, _tmp15_);
				_g_object_unref0 (text);
			}
		}
	}
	_tmp16_ = ibus_prop_list_new ();
	_tmp17_ = g_object_ref_sink (_tmp16_);
	_g_object_unref0 (self->priv->prop_list);
	self->priv->prop_list = _tmp17_;
	_tmp18_ = ibus_prop_list_new ();
	_tmp19_ = g_object_ref_sink (_tmp18_);
	props = _tmp19_;
	_tmp20_ = _ ("Hiragana");
	_tmp21_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_HIRAGANA, "InputMode.Hiragana", _tmp20_, "あ");
	_g_object_unref0 (prop);
	prop = _tmp21_;
	_tmp22_ = props;
	_tmp23_ = prop;
	ibus_prop_list_append (_tmp22_, _tmp23_);
	_tmp24_ = _ ("Katakana");
	_tmp25_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_KATAKANA, "InputMode.Katakana", _tmp24_, "ア");
	_g_object_unref0 (prop);
	prop = _tmp25_;
	_tmp26_ = props;
	_tmp27_ = prop;
	ibus_prop_list_append (_tmp26_, _tmp27_);
	_tmp28_ = _ ("HankakuKatakana");
	_tmp29_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_HANKAKU_KATAKANA, "InputMode.HankakuKatakana", _tmp28_, "_ｱ");
	_g_object_unref0 (prop);
	prop = _tmp29_;
	_tmp30_ = props;
	_tmp31_ = prop;
	ibus_prop_list_append (_tmp30_, _tmp31_);
	_tmp32_ = _ ("Latin");
	_tmp33_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_LATIN, "InputMode.Latin", _tmp32_, "_A");
	_g_object_unref0 (prop);
	prop = _tmp33_;
	_tmp34_ = props;
	_tmp35_ = prop;
	ibus_prop_list_append (_tmp34_, _tmp35_);
	_tmp36_ = _ ("WideLatin");
	_tmp37_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_WIDE_LATIN, "InputMode.WideLatin", _tmp36_, "Ａ");
	_g_object_unref0 (prop);
	prop = _tmp37_;
	_tmp38_ = props;
	_tmp39_ = prop;
	ibus_prop_list_append (_tmp38_, _tmp39_);
	_tmp40_ = _ ("Direct input");
	_tmp41_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_DIRECT, "InputMode.Direct", _tmp40_, "_A");
	_g_object_unref0 (prop);
	prop = _tmp41_;
	_tmp42_ = props;
	_tmp43_ = prop;
	ibus_prop_list_append (_tmp42_, _tmp43_);
	_tmp44_ = ibus_text_new_from_string ("あ");
	_tmp45_ = g_object_ref_sink (_tmp44_);
	_tmp46_ = _ ("Switch input mode");
	_tmp47_ = ibus_text_new_from_string (_tmp46_);
	_tmp48_ = g_object_ref_sink (_tmp47_);
	_tmp49_ = props;
	_tmp50_ = ibus_property_new ("InputMode", PROP_TYPE_MENU, _tmp45_, NULL, _tmp48_, TRUE, TRUE, PROP_STATE_UNCHECKED, _tmp49_);
	_tmp51_ = g_object_ref_sink (_tmp50_);
	_g_object_unref0 (prop);
	prop = _tmp51_;
	_g_object_unref0 (_tmp48_);
	_g_object_unref0 (_tmp45_);
	_tmp52_ = self->priv->prop_list;
	_tmp53_ = prop;
	ibus_prop_list_append (_tmp52_, _tmp53_);
	_tmp54_ = prop;
	_tmp55_ = _g_object_ref0 (_tmp54_);
	_g_object_unref0 (self->priv->input_mode_prop);
	self->priv->input_mode_prop = _tmp55_;
	_tmp56_ = _ ("Setup");
	_tmp57_ = ibus_text_new_from_string (_tmp56_);
	_tmp58_ = g_object_ref_sink (_tmp57_);
	_tmp59_ = _ ("Configure KKC");
	_tmp60_ = ibus_text_new_from_string (_tmp59_);
	_tmp61_ = g_object_ref_sink (_tmp60_);
	_tmp62_ = ibus_property_new ("setup", PROP_TYPE_NORMAL, _tmp58_, "gtk-preferences", _tmp61_, TRUE, TRUE, PROP_STATE_UNCHECKED, NULL);
	_tmp63_ = g_object_ref_sink (_tmp62_);
	_g_object_unref0 (prop);
	prop = _tmp63_;
	_g_object_unref0 (_tmp61_);
	_g_object_unref0 (_tmp58_);
	_tmp64_ = self->priv->prop_list;
	_tmp65_ = prop;
	ibus_prop_list_append (_tmp64_, _tmp65_);
	{
		KkcLanguageModel* _tmp66_ = NULL;
		KkcLanguageModel* _tmp67_;
		_tmp66_ = kkc_language_model_load ("sorted3", &_inner_error_);
		_tmp67_ = _tmp66_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == KKC_LANGUAGE_MODEL_ERROR) {
				goto __catch5_kkc_language_model_error;
			}
			_g_object_unref0 (model);
			_g_object_unref0 (prop);
			_g_object_unref0 (props);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
		}
		_g_object_unref0 (model);
		model = _tmp67_;
	}
	goto __finally5;
	__catch5_kkc_language_model_error:
	{
		GError* e = NULL;
		GError* _tmp68_;
		const gchar* _tmp69_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp68_ = e;
		_tmp69_ = _tmp68_->message;
		g_warning ("engine.vala:129: can't load language model: %s\n", _tmp69_);
		_g_error_free0 (e);
	}
	__finally5:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (model);
		_g_object_unref0 (prop);
		_g_object_unref0 (props);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_tmp70_ = model;
	_tmp71_ = kkc_context_new (_tmp70_);
	_g_object_unref0 (self->priv->context);
	self->priv->context = _tmp71_;
	{
		GeeArrayList* _tmp72_;
		GeeArrayList* _tmp73_;
		GeeArrayList* _dictionary_list;
		GeeArrayList* _tmp74_;
		gint _tmp75_;
		gint _tmp76_;
		gint _dictionary_size;
		gint _dictionary_index;
		_tmp72_ = kkc_engine_dictionaries;
		_tmp73_ = _g_object_ref0 (_tmp72_);
		_dictionary_list = _tmp73_;
		_tmp74_ = _dictionary_list;
		_tmp75_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp74_);
		_tmp76_ = _tmp75_;
		_dictionary_size = _tmp76_;
		_dictionary_index = -1;
		while (TRUE) {
			gint _tmp77_;
			gint _tmp78_;
			gint _tmp79_;
			GeeArrayList* _tmp80_;
			gint _tmp81_;
			gpointer _tmp82_ = NULL;
			KkcDictionary* dictionary;
			KkcContext* _tmp83_;
			KkcDictionaryList* _tmp84_;
			KkcDictionaryList* _tmp85_;
			KkcDictionary* _tmp86_;
			_tmp77_ = _dictionary_index;
			_dictionary_index = _tmp77_ + 1;
			_tmp78_ = _dictionary_index;
			_tmp79_ = _dictionary_size;
			if (!(_tmp78_ < _tmp79_)) {
				break;
			}
			_tmp80_ = _dictionary_list;
			_tmp81_ = _dictionary_index;
			_tmp82_ = gee_abstract_list_get ((GeeAbstractList*) _tmp80_, _tmp81_);
			dictionary = (KkcDictionary*) _tmp82_;
			_tmp83_ = self->priv->context;
			_tmp84_ = kkc_context_get_dictionaries (_tmp83_);
			_tmp85_ = _tmp84_;
			_tmp86_ = dictionary;
			kkc_dictionary_list_add (_tmp85_, _tmp86_);
			_g_object_unref0 (dictionary);
		}
		_g_object_unref0 (_dictionary_list);
	}
	kkc_engine_apply_preferences (self);
	_tmp87_ = kkc_engine_preferences;
	g_signal_connect_object (_tmp87_, "value-changed", (GCallback) __kkc_engine___lambda5__preferences_value_changed, self, 0);
	_tmp88_ = kkc_engine_preferences;
	g_signal_connect_object (_tmp88_, "value-changed", (GCallback) __kkc_engine___lambda6__preferences_value_changed, self, 0);
	_tmp89_ = self->priv->context;
	g_signal_connect_object ((GObject*) _tmp89_, "notify::input", (GCallback) __kkc_engine___lambda7__g_object_notify, self, 0);
	_tmp90_ = self->priv->context;
	g_signal_connect_object ((GObject*) _tmp90_, "notify::input-mode", (GCallback) __kkc_engine___lambda8__g_object_notify, self, 0);
	_tmp91_ = self->priv->context;
	_tmp92_ = kkc_context_get_candidates (_tmp91_);
	_tmp93_ = _tmp92_;
	g_signal_connect_object (_tmp93_, "populated", (GCallback) __kkc_engine___lambda9__kkc_candidate_list_populated, self, 0);
	_tmp94_ = self->priv->context;
	_tmp95_ = kkc_context_get_candidates (_tmp94_);
	_tmp96_ = _tmp95_;
	g_signal_connect_object ((GObject*) _tmp96_, "notify::cursor-pos", (GCallback) __kkc_engine___lambda10__g_object_notify, self, 0);
	_tmp97_ = self->priv->context;
	_tmp98_ = kkc_context_get_candidates (_tmp97_);
	_tmp99_ = _tmp98_;
	g_signal_connect_object (_tmp99_, "selected", (GCallback) __kkc_engine___lambda11__kkc_candidate_list_selected, self, 0);
	_tmp100_ = gtk_clipboard_get (GDK_SELECTION_PRIMARY);
	_tmp101_ = _g_object_ref0 (_tmp100_);
	_g_object_unref0 (self->priv->clipboard);
	self->priv->clipboard = _tmp101_;
	_tmp102_ = self->priv->context;
	g_signal_connect_object (_tmp102_, "request-selection-text", (GCallback) __kkc_engine___lambda12__kkc_context_request_selection_text, self, 0);
	kkc_engine_update_candidates (self);
	kkc_engine_update_input_mode (self);
	_g_object_unref0 (model);
	_g_object_unref0 (prop);
	_g_object_unref0 (props);
	return obj;
}


static KkcEngineKeyEntry* kkc_engine_key_entry_dup (const KkcEngineKeyEntry* self) {
	KkcEngineKeyEntry* dup;
	dup = g_new0 (KkcEngineKeyEntry, 1);
	memcpy (dup, self, sizeof (KkcEngineKeyEntry));
	return dup;
}


static void kkc_engine_key_entry_free (KkcEngineKeyEntry* self) {
	g_free (self);
}


static GType kkc_engine_key_entry_get_type (void) {
	static volatile gsize kkc_engine_key_entry_type_id__volatile = 0;
	if (g_once_init_enter (&kkc_engine_key_entry_type_id__volatile)) {
		GType kkc_engine_key_entry_type_id;
		kkc_engine_key_entry_type_id = g_boxed_type_register_static ("KkcEngineKeyEntry", (GBoxedCopyFunc) kkc_engine_key_entry_dup, (GBoxedFreeFunc) kkc_engine_key_entry_free);
		g_once_init_leave (&kkc_engine_key_entry_type_id__volatile, kkc_engine_key_entry_type_id);
	}
	return kkc_engine_key_entry_type_id__volatile;
}


static void kkc_engine_class_init (KkcEngineClass * klass) {
	kkc_engine_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (KkcEnginePrivate));
	IBUS_ENGINE_CLASS (klass)->process_key_event = kkc_engine_real_process_key_event;
	IBUS_ENGINE_CLASS (klass)->enable = kkc_engine_real_enable;
	IBUS_ENGINE_CLASS (klass)->disable = kkc_engine_real_disable;
	IBUS_ENGINE_CLASS (klass)->reset = kkc_engine_real_reset;
	IBUS_ENGINE_CLASS (klass)->focus_in = kkc_engine_real_focus_in;
	IBUS_ENGINE_CLASS (klass)->focus_out = kkc_engine_real_focus_out;
	IBUS_ENGINE_CLASS (klass)->property_activate = kkc_engine_real_property_activate;
	G_OBJECT_CLASS (klass)->constructor = kkc_engine_constructor;
	G_OBJECT_CLASS (klass)->finalize = kkc_engine_finalize;
}


static void kkc_engine_instance_init (KkcEngine * self) {
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar** _tmp17_ = NULL;
	self->priv = KKC_ENGINE_GET_PRIVATE (self);
	_tmp0_ = gee_hash_map_new (KKC_TYPE_INPUT_MODE, NULL, NULL, IBUS_TYPE_PROPERTY, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
	self->priv->input_mode_props = (GeeMap*) _tmp0_;
	_tmp1_ = gee_hash_map_new (KKC_TYPE_INPUT_MODE, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
	self->priv->input_mode_symbols = (GeeMap*) _tmp1_;
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, KKC_TYPE_INPUT_MODE, NULL, NULL, NULL, NULL, NULL);
	self->priv->name_input_modes = (GeeMap*) _tmp2_;
	_tmp3_ = g_strdup ("1");
	_tmp4_ = g_strdup ("2");
	_tmp5_ = g_strdup ("3");
	_tmp6_ = g_strdup ("4");
	_tmp7_ = g_strdup ("5");
	_tmp8_ = g_strdup ("6");
	_tmp9_ = g_strdup ("7");
	_tmp10_ = g_strdup ("8");
	_tmp11_ = g_strdup ("9");
	_tmp12_ = g_strdup ("a");
	_tmp13_ = g_strdup ("b");
	_tmp14_ = g_strdup ("c");
	_tmp15_ = g_strdup ("d");
	_tmp16_ = g_strdup ("e");
	_tmp17_ = g_new0 (gchar*, 14 + 1);
	_tmp17_[0] = _tmp3_;
	_tmp17_[1] = _tmp4_;
	_tmp17_[2] = _tmp5_;
	_tmp17_[3] = _tmp6_;
	_tmp17_[4] = _tmp7_;
	_tmp17_[5] = _tmp8_;
	_tmp17_[6] = _tmp9_;
	_tmp17_[7] = _tmp10_;
	_tmp17_[8] = _tmp11_;
	_tmp17_[9] = _tmp12_;
	_tmp17_[10] = _tmp13_;
	_tmp17_[11] = _tmp14_;
	_tmp17_[12] = _tmp15_;
	_tmp17_[13] = _tmp16_;
	self->priv->LOOKUP_TABLE_LABELS = _tmp17_;
	self->priv->LOOKUP_TABLE_LABELS_length1 = 14;
	self->priv->_LOOKUP_TABLE_LABELS_size_ = self->priv->LOOKUP_TABLE_LABELS_length1;
	self->priv->save_dictionaries_timeout_id = (guint) 0;
}


static void kkc_engine_finalize (GObject* obj) {
	KkcEngine * self;
	self = KKC_ENGINE (obj);
	_g_object_unref0 (self->priv->context);
	_g_object_unref0 (self->priv->lookup_table);
	_g_object_unref0 (self->priv->input_mode_prop);
	_g_object_unref0 (self->priv->prop_list);
	_g_object_unref0 (self->priv->input_mode_props);
	_g_object_unref0 (self->priv->input_mode_symbols);
	_g_object_unref0 (self->priv->name_input_modes);
	_g_object_unref0 (self->priv->clipboard);
	self->priv->LOOKUP_TABLE_LABELS = (_vala_array_free (self->priv->LOOKUP_TABLE_LABELS, self->priv->LOOKUP_TABLE_LABELS_length1, (GDestroyNotify) g_free), NULL);
	G_OBJECT_CLASS (kkc_engine_parent_class)->finalize (obj);
}


GType kkc_engine_get_type (void) {
	static volatile gsize kkc_engine_type_id__volatile = 0;
	if (g_once_init_enter (&kkc_engine_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (KkcEngineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) kkc_engine_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KkcEngine), 0, (GInstanceInitFunc) kkc_engine_instance_init, NULL };
		GType kkc_engine_type_id;
		kkc_engine_type_id = g_type_register_static (IBUS_TYPE_ENGINE, "KkcEngine", &g_define_type_info, 0);
		g_once_init_leave (&kkc_engine_type_id__volatile, kkc_engine_type_id);
	}
	return kkc_engine_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



